//!
//! @file config.h,v
//!
//! Copyright (c) 2007 Atmel.
//!
//! @brief ̧ѳ`Ԑݒ
//!
//! @version 1.14
//!

//_____ ݸٰ _______________________________________________________________

#ifdef __GNUC__
 #include "gcc_compiler.h"
 #include <avr/io.h>
 #include <avr/pgmspace.h>
 #include <avr/interrupt.h>

 #define putchar(c)				uart_putchar(c)
 #define getchar(c)				uart_getchar(c)

 #define Uchar					U8
 #define Uint32					U32
 #define Enable_interrupt()		__enable_interrupt
 #define Disable_interrupt()	__disable_interrupt
 #define code					PROGMEM
// #define code
 #define MSB(u16)				(((U8* )&u16)[1])
 #define LSB(u16)				(((U8* )&u16)[0])
 #define HIGH(v)				MSB(v)
 #define LOW(v)					LSB(v)

 #define ADASCR					4
 #define AMP1ND					0
 #define AMP1PD					1
 #define ACMP1D					2
 #define PLLOCK					0

/* AMP0CSR  */
#define AMP0EN		7
#define AMP0IS		6
#define AMP0G1		5
#define AMP0G0		4
#define AMP0TS2		2
#define AMP0TS1		1
#define AMP0TS0		0

/* AMP1CSR  */
#define AMP1EN		7
#define AMP1IS		6
#define AMP1G1		5
#define AMP1G0		4
#define AMP1TS2		2
#define AMP1TS1		1
#define AMP1TS0		0

#else
 #include "compiler.h"
 #include "mcu.h"
 #include "inavr.h"
#endif

#include "config_motor.h"

#ifndef _CONFIG_H_
#define _CONFIG_H_
#endif

#define BOARD_ID	1	/* 0:m, 1:MC100, 2:MC200 */
#define SOFT_ID		1	/* 0:m, 1:BLDCmL, 2:BLDC, 3:BLDCmȂ */
#define REV_ID		1

/*-------------- UART LIB`Ԑݒ ---------------*/

#define BAUDRATE	38400
#define FOSC		16000

#define uart_putchar putchar

//! @defgroup ADC_defines_configuration_values A/Dϊ`Ԑݒl`
//! ]ތ`ԐݒA/Dϊ평`
//! @{
#define USE_ADC

#define ADC_RIGHT_ADJUST_RESULT		0	//!< 0:ʍA1:ʉE
#define ADC_HIGH_SPEED_MODE			1	//
#define ADC_INTERNAL_VREF			1	//!< 0:OdA1:dA2:Vcc(VrefVccɐڑ)
#define ADC_IT						1	//!< 0:A/Dϊ荞݂ȂA1:A/Dϊ荞ݗL
#define ADC_PRESCALER				4	//!< 2,4,8,16,32,64,128 : A/Dϊg͂̒萔lŕꂽ ۯgłB

//! @defgroup DAC_defines_configuration_values D/Aϊ`Ԑݒl`
//! ]ތ`ԐݒD/Aϊ평`
//! @{
#define USE_DAC

#define DAC_INPUT_RIGHT_ADJUST		0	//!< 0:A1:E
#define DAC_INTERNAL_VREF			1	//!<
#define DAC_OUTPUT_DRIVER			1	//!<

//! @defgroup COMPARATORs_defines_configuration_values r`Ԑݒl`
//! ]ތ`ԐݒŔr평`
//! @{
#define USE_COMP0
#define COMPARATOR0_IT				1	//!< 0:r튄荞݋֎~A1:r튄荞݋
#define COMPARATOR0_IT_EVENT		0	//!< r튄荞ݎ=> 0:؂ւA2:~[A3:㏸[
#define COMPARATOR0_NEGATIVE_INPUT	4	//!< r픽]͑I=> 0:Vref/6.40A1:Vref/3.20A2:Vref/2.13A3:Vref/1.60A4:ACMPMA5:D/Aϊo

#define USE_COMP1
#define COMPARATOR1_IT				1	//!< 0:r튄荞݋֎~A1:r튄荞݋
#define COMPARATOR1_IT_EVENT		0	//!< r튄荞ݎ=> 0:؂ւA2:~[A3:㏸[
#define COMPARATOR1_NEGATIVE_INPUT	4	//!< r픽]͑I=> 0:Vref/6.40A1:Vref/3.20A2:Vref/2.13A3:Vref/1.60A4:ACMPMA5:D/Aϊo

#define USE_COMP2
#define COMPARATOR2_IT				1	//!< 0:r튄荞݋֎~A1:r튄荞݋
#define COMPARATOR2_IT_EVENT		0	//!< r튄荞ݎ=> 0:؂ւA2:~[A3:㏸[
#define COMPARATOR2_NEGATIVE_INPUT	4	//!< r픽]͑I=> 0:Vref/6.40A1:Vref/3.20A2:Vref/2.13A3:Vref/1.60A4:ACMPMA5:D/Aϊo
